<?php
/*
Version 3.1, 28-11-2014
Author J. den Haan
http://www.den-haan.net
before editing, read the manual!
*/
if(!defined("auth")) exit;
// functions for REST search interface
// DO NOT EDIT THIS FILE UNLESS YOU KNOW WHAT YOU ARE DOING!!!

//this function return the right key for the search string
function getKey($key)
{
	switch ($key)
	{
	case "isbn";
        $key1 = "";
		$flags1= "1";
        break;
	case "author";
        $key1 = "contributor";
		$flags1= "1";
        break;
	case "publisher":
        $key1 = "publisher";
		$flags1= "0";
        break;
	case "nur":
        $key1 = "nur";
		$flags1= "0";
        break;
	case "geo":
        $key1 = "geo";
		$flags1= "0";
        break;
	default:
		$key1 = "title";
		$flags1= "0";
	}
	$arr[0] = $key1;
	$arr[1] = $flags1;
	return $arr;
}

//this function returns an array of books based on search terms from the rest interface
function getBookList($key1, $value1, $flags1, $config_base_url, $config_limit, $config_debug)  
{ 
	//look for results in the btnew database
	$url = build_url($key1, $value1, $flags1, $config_base_url, $config_limit);
	echo ($config_debug == "true" ? $url."<br />" : "");
	echo $url;
	$xml = @file_get_contents($url);
	$b = array();
	if($xml!="")
    {
		$i = 0;
		$xml = new SimpleXMLElement($xml);
		foreach ($xml->book as $book)
		{
			$b["$i"]["ref"] = $book->isbn13;
			$b["$i"]["img"] = $book->image;
			$b["$i"]["title"] = $book->title;
			$b["$i"]["isbn"] = $book->isbn13;
			$b["$i"]["adviesprijs"] = $book->adviesprijs;
			$b["$i"]["url"] = str_replace("book/", "", $book->details);
			
			foreach($book->contributor as $item) {
				$key = $item->attributes()->role;
				$b["$i"]["$key"] = $item;
			}
			
			$i ++;
		}
		return $b;
    }
}

//this function returns an array of one book based on the internal identifier from the rest interface
function getBook($url)  
{ 
	$xml = @file_get_contents($url);
	//echo $xml;
	if($xml!="")
    {	
		$x = 1;
		$i = 1;
		$xml = new SimpleXMLElement($xml);
		foreach ($xml->Product as $book)
		{
			
			$b["$i"]["ref"] = $book->RecordReference;
			$b["$i"]["img"] = $book->MediaFile->MediaFileLink;
			$b["$i"]["title"] = $book->Title->TitleText;
			$b["$i"]["subTitle"] = $book->Title->SubTitleText;
			$b["$i"]["publicationDate"] = $book->PublicationDate;
			$b["$i"]["text"] = cut($book->OtherText->Text,300);
			$b["$i"]["fullText"] = $book->OtherText->Text;
			$b["$i"]["publisher"] = $book->Imprint->ImprintName;
			$b["$i"]["publisherPrice"] ="";
			$b["$i"]["cbPrice"] = "";
			foreach($book->SupplyDetail as $supplier)
			{
				if($supplier->SupplierName == "Publisher")
				{
					$b["$i"]["publisherPrice"] = $supplier->Price->PriceAmount;
				}
				else
				{
					
					foreach($supplier->Price as $pr)
					{					
						if($pr->PriceTypeCode == "4")
						{
							$b["$i"]["cbPrice"] = $pr->PriceAmount;
						}
						else
						{
							$b["$i"]["cbPriceEx"] = $pr->PriceAmount;
						}
					}
				}
			}
			foreach($book->ProductIdentifier as $isbn)
			{
				if($isbn->ProductIDType =="15")
				{
					$b["$i"]["isbn"] = $isbn->IDValue;
				}
			}
			if(isset($book->ProductWebsite->ProductWebsiteLink)) {
				$b["$i"]["productWebsite"] = $book->ProductWebsite->ProductWebsiteLink;
			}
			if (isset($book->Publisher->Website->WebsiteLink)) {
				$b["$i"]["publisherWebsite"] = $book->Publisher->Website->WebsiteLink;
			}
			if(isset($book->NumberOfPages)) {
				$b["$i"]["pages"] = $book->NumberOfPages;
			}
			if(isset($book->Contributor->PersonName)) {
				$b["$i"]["author"] = $book->Contributor->PersonName;
			}
			$i ++;
		}
		return $b;
    }
	else
    {
	    echo "Er is iets fout gegaan bij het ophalen van de gegevens!<br />"; 
    }
}

//this function returns a shorter version of a piece of text
function cut($verylongstring, $length) 
{
	if (strlen($verylongstring) > $length) 
	{
		$shorterstring = substr($verylongstring,0,$length-1);
	}
	else
	{
		$shorterstring = $verylongstring;
	}
	return $shorterstring;
}
	
//this function returns an a trimmed version of an URL, HTTP and URl are stripped form the inputted URl
function clean_url($link)
{
	// get host name from URL
	$str = ereg_replace("(http?)://", "", $link);
	$str = ereg_replace("(URL?):", "", $str);
	return trim($str);
}

//this function returns a complete URL based for the rest interface
function build_url($key1, $value1, $flags1, $config_base_url, $config_limit)
{
	$value1 = urlencode($value1);
	$url = $config_base_url."/search?key1=".$key1."&value1=".$value1."&flags1=" . $flags1 . "&limit=".$config_limit."&resultSetType=frontpage";
	return $url;
}

// mailform functions
/* name: input_check_mailinj() 
 * sample usage: foreach($_POST as $value) input_check_mailinj($value); 
 */ 

function input_check_mailinj($value) 
{ 
   
   # mail adress(ess) for reports... 
   $report_to = ""; 
   $from_server = "noreply@boek.nl";

   # array holding strings to check... 
   $suspicious_str = array 
   ( 
       "content-type" 
       ,"charset=" 
       ,"mime-version:" 
       ,"multipart/mixed" 
       ,"bcc" 
	   ,"BCC"
	   ,"cc:"
	   ,"CC:"
	   ,"To:"
	   ,"TO:"
	   ,"to:"
	   ,"http:"
	   ,"HTTP:"
   ); 

   // remove added slashes from $value... 
   $value = stripslashes($value); 

   foreach($suspicious_str as $suspect) 
   { 
       # checks if $value contains $suspect... 
       if(eregi($suspect, strtolower($value))) 
       { 
           // replace this with your own get_ip function... 
           $ip = (empty($_SERVER['REMOTE_ADDR'])) ? 'empty' 
               : $_SERVER['REMOTE_ADDR']; 
           $rf = (empty($_SERVER['HTTP_REFERER'])) ? 'empty' 
               : $_SERVER['HTTP_REFERER']; 
           $ua = (empty($_SERVER['HTTP_USER_AGENT'])) ? 'empty' 
               : $_SERVER['HTTP_USER_AGENT']; 
           $ru = (empty($_SERVER['REQUEST_URI'])) ? 'empty' 
               : $_SERVER['REQUEST_URI']; 
           $rm = (empty($_SERVER['REQUEST_METHOD'])) ? 'empty' 
               : $_SERVER['REQUEST_METHOD']; 

           # if so, file a report... 
           if(isset($report_to) && !empty($report_to)) 
           { 
		   $title ="[ABUSE] mailinjection @ ".$_SERVER['HTTP_HOST']." by " .$ip;
		   $msg ="Stopped possible mail-injection @ ".$_SERVER['HTTP_HOST']." by ".$ip." (".date('d/m/Y H:i:s').")\r\n\r\n". 
                     "*** IP/HOST\r\n" . $ip . "\r\n\r\n" . 
                     "*** USER AGENT\r\n" . $ua . "\r\n\r\n" . 
                     "*** REFERER\r\n" . $rf . "\r\n\r\n" . 
                     "*** REQUEST URI\r\n" . $ru . "\r\n\r\n" . 
                     "*** REQUEST METHOD\r\n" . $rm . "\r\n\r\n" . 
                     "*** SUSPECT\r\n--\r\n".$value;
			$from ="From: ".$from_server." <".$from_server.">";
            
			//@mail($report_to, $title, $msg, $from);
           } 

           # ... and kill the script. 
           die 
           ( 
               'Script processing cancelled: string 
               (`<em>'.$value.'</em>`) contains text portions that 
               are potentially harmful to this server. <em>Your input 
               has not been sent!</em> Please use your browser\'s 
               `back`-button to return to the previous page and try 
               rephrasing your input.</p>' 
           ); 
       } 
   } 
} 
?>